package com.vendor.loader.ui;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.loader.Activator;
import com.vendor.loader.ImageFactory;
import com.vendor.loader.Messages;
import com.vendor.loader.controler.GlobleControler;
import com.vendor.loader.controler.IRunnerStateChangedListener;
import com.vendor.loader.struct.BurnType;
import com.vendor.loader.struct.FileSystem;
import com.vendor.loader.struct.FlashType;
import com.vendor.loader.struct.UpgradeFileInfo;
import com.vendor.loader.ui.ControlFactory;
import com.vendor.loader.ui.FileCellEditor;
import com.vendor.loader.util.FileUtil;
import java.awt.Toolkit;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.layout.TableColumnLayout;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.CheckboxTableViewer;
import org.eclipse.jface.viewers.ColumnLayoutData;
import org.eclipse.jface.viewers.ColumnPixelData;
import org.eclipse.jface.viewers.ColumnWeightData;
import org.eclipse.jface.viewers.ComboBoxCellEditor;
import org.eclipse.jface.viewers.IBaseLabelProvider;
import org.eclipse.jface.viewers.ICellEditorListener;
import org.eclipse.jface.viewers.ICellModifier;
import org.eclipse.jface.viewers.ICheckStateListener;
import org.eclipse.jface.viewers.IContentProvider;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.swt.custom.TableEditor;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Widget;

public abstract class AbstractComposite extends Composite implements IRunnerStateChangedListener {
  protected List<UpgradeFileInfo> updateFiles;
  
  protected boolean useXMLPathAsParent = true;
  
  private static int COL_SEL;
  
  private static int PARTITIONNAMECOL;
  
  private static int PARTITIONVERSIONCOL;
  
  private static int PARTITIONVERIFYTAGCOL;
  
  private static int COL_ADD;
  
  private static int FILE_NAME_COL;
  
  private static int File_Length_COL;
  
  private static int START_ADDRESS_COL;
  
  private static int FLASH_INDEX_COL;
  
  private static int FILE_SYSTEM_COL;
  
  private static int FLASH_TYPE_COL;
  
  private CheckboxTableViewer viewer;
  
  private static String[] COLUMN_PROPERTIES;
  
  private static String[] TABLE_HEADERS;
  
  private int labelWidth = 0;
  
  private int minHeight = 768;
  
  private ComboBoxCellEditor flashTypeEditor;
  
  private ComboBoxCellEditor fileSystemEditor;
  
  private Text textField;
  
  public int getLabelWidth() {
    return this.labelWidth;
  }
  
  public void setLabelWidth(int labelWidth) {
    this.labelWidth = labelWidth;
  }
  
  public AbstractComposite(Composite parent, int style) {
    super(parent, style);
    GridLayout layout = new GridLayout();
    layout.verticalSpacing = 15;
    setLayout((Layout)layout);
    createLoaderContents(this);
  }
  
  protected abstract void createLoaderContents(Composite paramComposite);
  
  protected abstract String[] getChipList();
  
  protected abstract void saveIni(String paramString);
  
  protected abstract String loadIni();
  
  protected abstract void setUseXMLPathAsParent(boolean paramBoolean);
  
  protected TableViewer getViewer() {
    return (TableViewer)this.viewer;
  }
  
  protected void createXMLPathAsParentButton(Group partGroup) {
    Button useXMLPathAsParentButton = new Button((Composite)partGroup, 32);
    GridData gd = new GridData();
    gd.widthHint = 320;
    useXMLPathAsParentButton.setLayoutData(gd);
    useXMLPathAsParentButton.setText(Messages.LabelDefaultUseXmlPath);
    useXMLPathAsParentButton.setSelection(true);
    useXMLPathAsParentButton.addListener(13, (Listener)new Object(this, useXMLPathAsParentButton));
  }
  
  protected void createPartFileContentControl(Composite parent, int heightHint) {
    Group partGroup = ControlFactory.createGroup(parent, Messages.LoaderComposite_43, 5);
    createXMLPathAsParentButton(partGroup);
    int width = 150;
    GridData gd = new GridData();
    gd.widthHint = 150;
    Label label = ControlFactory.createLabel((Composite)partGroup, Messages.LoaderComposite_ConfigFile);
    label.setLayoutData(gd);
    int partGroupWidth = 510;
    this.textField = ControlFactory.createTsTextField((Composite)partGroup, 2052, 510);
    this.textField.setFont(partGroup.getFont());
    Button loadButton = new Button((Composite)partGroup, 8);
    gd = new GridData();
    loadButton.setLayoutData(gd);
    FileUtil.setWidthForOS(gd, 205, 150);
    loadButton.setText(Messages.SelectFileDialog_24);
    loadButton.addSelectionListener((SelectionListener)new Object(this));
    Button saveButton = new Button((Composite)partGroup, 8);
    gd = new GridData();
    saveButton.setLayoutData(gd);
    FileUtil.setWidthForOS(gd, 205, 150);
    saveButton.setText(Messages.SelectFileDialog_SaveConfig);
    saveButton.addSelectionListener((SelectionListener)new Object(this));
    createTableViewer((Composite)partGroup, heightHint);
    GlobleControler.intance.addRunnerStateChangedListener(this);
  }
  
  protected void createTableViewer(Composite parent, int heightHint) {
    Composite control = new Composite(parent, 2048);
    TableColumnLayout tcl = new TableColumnLayout();
    control.setLayout((Layout)tcl);
    GridData gd = null;
    int screenHeight = (Toolkit.getDefaultToolkit().getScreenSize()).height;
    if (screenHeight <= this.minHeight) {
      gd = new GridData();
      gd.widthHint = 1300;
    } else {
      gd = new GridData(1808);
    } 
    gd.horizontalSpan = 5;
    gd.heightHint = heightHint;
    control.setLayoutData(gd);
    this.viewer = CheckboxTableViewer.newCheckList(control, 66064);
    this.viewer.setContentProvider((IContentProvider)new ViewContentProvider(this));
    this.viewer.setLabelProvider((IBaseLabelProvider)new ViewLabelProvider(this));
    Table table = this.viewer.getTable();
    table.setHeaderVisible(true);
    table.setLinesVisible(true);
    table.addListener(41, (Listener)new Object(this, table));
    int minWeidth = 20;
    TableColumn column = null;
    column = new TableColumn(table, 16777216, COL_SEL);
    column.setImage(Activator.getImage("icons/check.bmp"));
    column.setResizable(true);
    column.setMoveable(true);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnPixelData(35, false));
    column.addListener(13, (Listener)new Object(this));
    this.viewer.addCheckStateListener((ICheckStateListener)new Object(this));
    if (GlobleControler.intance.is64Bit()) {
      PARTITIONNAMECOL = 1;
      PARTITIONVERSIONCOL = 2;
      PARTITIONVERIFYTAGCOL = 3;
      COL_ADD = 10;
      FILE_NAME_COL = 4;
      File_Length_COL = 9;
      START_ADDRESS_COL = 8;
      FLASH_INDEX_COL = 7;
      FILE_SYSTEM_COL = 6;
      FLASH_TYPE_COL = 5;
      COLUMN_PROPERTIES = new String[] { "sel", "name", "version", "verify", "file", "type", "system", "index", "start", "length" };
      TABLE_HEADERS = new String[] { Messages.SEL, Messages.PARTITIONNAMECOL, Messages.PARTITIONVERSIONCOL, Messages.PARTITIONVERIFYTAGCOL, Messages.LoaderComposite_4, Messages.LoaderComposite_0, Messages.LoaderComposite_FileSystem, Messages.LoaderComposite_1, Messages.LoaderComposite_2, Messages.LoaderComposite_3 };
      column = new TableColumn(table, 16384, PARTITIONNAMECOL);
      column.setResizable(true);
      column.setMoveable(false);
      column.setText(TABLE_HEADERS[PARTITIONNAMECOL]);
      column.setAlignment(131072);
      tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(3, 20, false));
      column = new TableColumn(table, 16384, PARTITIONVERSIONCOL);
      column.setResizable(true);
      column.setMoveable(false);
      column.setText(TABLE_HEADERS[PARTITIONVERSIONCOL]);
      column.setAlignment(131072);
      tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(3, 20, false));
      column = new TableColumn(table, 16384, PARTITIONVERIFYTAGCOL);
      column.setResizable(true);
      column.setMoveable(false);
      column.setText(TABLE_HEADERS[PARTITIONVERIFYTAGCOL]);
      column.setAlignment(131072);
      tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(3, 20, false));
    } else {
      COL_ADD = 7;
      FILE_NAME_COL = 1;
      File_Length_COL = 6;
      START_ADDRESS_COL = 5;
      FLASH_INDEX_COL = 4;
      FILE_SYSTEM_COL = 3;
      FLASH_TYPE_COL = 2;
      COLUMN_PROPERTIES = new String[] { "sel", "file", "type", "system", "index", "start", "length" };
      TABLE_HEADERS = new String[] { Messages.SEL, Messages.LoaderComposite_4, Messages.LoaderComposite_0, Messages.LoaderComposite_FileSystem, Messages.LoaderComposite_1, Messages.LoaderComposite_2, Messages.LoaderComposite_3 };
    } 
    column = new TableColumn(table, 16384, FILE_NAME_COL);
    column.setResizable(true);
    column.setMoveable(false);
    column.setText(TABLE_HEADERS[FILE_NAME_COL]);
    column.setAlignment(131072);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(6, 20, false));
    column = new TableColumn(table, 16777216, FLASH_TYPE_COL);
    column.setResizable(true);
    column.setMoveable(false);
    column.setText(TABLE_HEADERS[FLASH_TYPE_COL]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(3, 20, false));
    column = new TableColumn(table, 16777216, FILE_SYSTEM_COL);
    column.setResizable(true);
    column.setMoveable(false);
    column.setText(TABLE_HEADERS[FILE_SYSTEM_COL]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(3, 20, false));
    column = new TableColumn(table, 16777216, FLASH_INDEX_COL);
    column.setResizable(true);
    column.setMoveable(false);
    column.setText(TABLE_HEADERS[FLASH_INDEX_COL]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(3, 20, false));
    column = new TableColumn(table, 16777216, START_ADDRESS_COL);
    column.setResizable(true);
    column.setMoveable(false);
    column.setText(TABLE_HEADERS[START_ADDRESS_COL]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(3, 20, false));
    column = new TableColumn(table, 16777216, File_Length_COL);
    column.setResizable(true);
    column.setMoveable(false);
    column.setText(TABLE_HEADERS[File_Length_COL]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(3, 20, false));
    TableColumn addCol = new TableColumn(table, 16777216, COL_ADD);
    addCol.setAlignment(16777216);
    addCol.setMoveable(true);
    addCol.setResizable(false);
    tcl.setColumnData((Widget)addCol, (ColumnLayoutData)new ColumnPixelData(50, false));
    addCol.setImage(ImageFactory.getImage("/icons/add.jpg"));
    addCol.addListener(13, (Listener)new Object(this, parent));
    TableEditor dataEditor = new TableEditor(table);
    dataEditor.horizontalAlignment = 16777216;
    dataEditor.grabHorizontal = true;
    dataEditor.minimumWidth = 20;
    this.viewer.addSelectionChangedListener((ISelectionChangedListener)new Object(this, dataEditor, table));
    addCellEditors();
    this.updateFiles = new ArrayList<>();
    this.viewer.setInput(this.updateFiles);
  }
  
  protected void handleAddNewPartition() {
    StructuredSelection selection = (StructuredSelection)this.viewer.getSelection();
    int index = -1;
    FlashType flashType = null;
    int flashIndex = 0;
    if (!selection.isEmpty()) {
      UpgradeFileInfo info = (UpgradeFileInfo)selection.getFirstElement();
      flashType = info.getFlashType();
      flashIndex = info.getFlashIndex();
      index = this.updateFiles.indexOf(info);
    } else if (this.updateFiles.size() > 0) {
      UpgradeFileInfo info = this.updateFiles.get(this.updateFiles.size() - 1);
      flashType = info.getFlashType();
      flashIndex = info.getFlashIndex();
    } 
    if (flashType == null)
      flashType = FlashType.nand; 
    UpgradeFileInfo newItem = new UpgradeFileInfo();
    newItem.setFlashType(flashType);
    newItem.setFileSystem(FileSystem.valueOf(FileSystem.getItems()[0]));
    newItem.setFlashIndex(flashIndex & 0xFFFF);
    if (index != -1 && index <= this.updateFiles.size() - 1) {
      UpgradeFileInfo lastFileInfo = this.updateFiles.get(index);
      long calcAddress = (lastFileInfo.getStartAddress() + lastFileInfo.getLength() < 0L) ? 0L : (lastFileInfo.getStartAddress() + lastFileInfo.getLength());
      newItem.setStartAddress(calcAddress);
      newItem.setEndAddress(calcAddress);
    } 
    this.updateFiles.add(++index, newItem);
    updateAddressesForAddNew(newItem, index);
    this.viewer.refresh();
    this.viewer.setSelection((ISelection)new StructuredSelection(newItem), true);
  }
  
  private void updateSelection() {
    TableItem[] items = this.viewer.getTable().getItems();
    for (TableItem tableItem : items) {
      if (tableItem.getData() instanceof UpgradeFileInfo) {
        UpgradeFileInfo info = (UpgradeFileInfo)tableItem.getData();
        tableItem.setChecked(info.isSel());
      } 
    } 
  }
  
  public Integer getInteger(Object value) {
    Integer index = Integer.valueOf(0);
    if (index instanceof Object)
      index = (Integer)value; 
    if (index.intValue() == -1)
      index = Integer.valueOf(0); 
    return index;
  }
  
  private void addCellEditors() {
    this
      .flashTypeEditor = new ComboBoxCellEditor((Composite)this.viewer.getTable(), FlashType.getItems(), 8);
    this.flashTypeEditor.addListener((ICellEditorListener)new Object(this));
    this
      .fileSystemEditor = new ComboBoxCellEditor((Composite)this.viewer.getTable(), FileSystem.getItems(this.flashTypeEditor.getItems()[0]), 8);
    ComboBoxCellEditor chipTypeEditor = new ComboBoxCellEditor((Composite)this.viewer.getTable(), getChipList(), 8);
    TextCellEditor startAddressEditor = new TextCellEditor((Composite)this.viewer.getTable());
    TextCellEditor fileLengthEditor = new TextCellEditor((Composite)this.viewer.getTable());
    FileCellEditor fileEditor = new FileCellEditor((Composite)this.viewer.getTable());
    TextCellEditor partitionNameEditor = new TextCellEditor((Composite)this.viewer.getTable());
    TextCellEditor partitionVersionEditor = new TextCellEditor((Composite)this.viewer.getTable());
    TextCellEditor partitionverity = new TextCellEditor((Composite)this.viewer.getTable());
    setCellEditors(chipTypeEditor, startAddressEditor, fileLengthEditor, fileEditor, partitionNameEditor, partitionVersionEditor, partitionverity);
    this.viewer.setColumnProperties(COLUMN_PROPERTIES);
    this.viewer.setCellModifier((ICellModifier)new Object(this));
  }
  
  private void setCellEditors(ComboBoxCellEditor chipTypeEditor, TextCellEditor startAddressEditor, TextCellEditor fileLengthEditor, FileCellEditor fileEditor, TextCellEditor partitionNameEditor, TextCellEditor partitionVersionEditor, TextCellEditor partitionverity) {
    if (GlobleControler.intance.is64Bit()) {
      this.viewer.setCellEditors(new CellEditor[] { 
            null, (CellEditor)partitionNameEditor, (CellEditor)partitionVersionEditor, (CellEditor)partitionverity, (CellEditor)fileEditor, (CellEditor)this.flashTypeEditor, (CellEditor)this.fileSystemEditor, (CellEditor)chipTypeEditor, (CellEditor)startAddressEditor, (CellEditor)fileLengthEditor, 
            null });
    } else {
      this.viewer.setCellEditors(new CellEditor[] { null, (CellEditor)fileEditor, (CellEditor)this.flashTypeEditor, (CellEditor)this.fileSystemEditor, (CellEditor)chipTypeEditor, (CellEditor)startAddressEditor, (CellEditor)fileLengthEditor, null });
    } 
  }
  
  protected void showMessage(String message) {
    MessageDialog.openInformation(this.viewer.getControl().getShell(), Messages.LoaderComposite_9, message);
  }
  
  protected void showError(String message) {
    MessageDialog.openError(Display.getDefault().getActiveShell(), Messages.LoaderComposite_10, message);
  }
  
  protected void removeFile() {
    IStructuredSelection selection = (IStructuredSelection)this.viewer.getSelection();
    UpgradeFileInfo info = (UpgradeFileInfo)selection.getFirstElement();
    if (info == null)
      return; 
    this.updateFiles.remove(info);
    this.viewer.refresh();
  }
  
  protected void updateAddressAtControlChanged(UpgradeFileInfo part, FlashType oldType, int flashIndex) {
    part.setStartAddress(getLastAddress(part));
    updateAddress(part);
    long address = 0L;
    for (UpgradeFileInfo item : this.updateFiles) {
      if (item.getFlashType() != oldType || (item
        .getFlashIndex() & 0xFFFF) != (flashIndex & 0xFFFF))
        continue; 
      if (address == 0L) {
        address = item.getStartAddress();
      } else {
        item.setStartAddress(address);
        item.setEndAddress(address + item.getLength());
      } 
      address += item.getLength();
    } 
    this.viewer.refresh();
  }
  
  protected long getLastAddress(UpgradeFileInfo part) {
    if (!this.updateFiles.contains(part))
      return 0L; 
    long address = 0L;
    int curPartIndex = this.updateFiles.indexOf(part);
    int lastPartIndex = -1;
    UpgradeFileInfo lastPart = null;
    while ((lastPartIndex = curPartIndex - 1) != -1) {
      lastPart = this.updateFiles.get(lastPartIndex);
      if (part.getFlashType() == lastPart.getFlashType() && (part
        .getFlashIndex() & 0xFFFF) == (lastPart
        .getFlashIndex() & 0xFFFF)) {
        address += lastPart.getStartAddress();
        if (lastPart.getLength() > 0L)
          address += lastPart.getLength(); 
        break;
      } 
      curPartIndex--;
    } 
    return address;
  }
  
  protected void updateAddress(UpgradeFileInfo part) {
    long address = 0L;
    for (UpgradeFileInfo item : this.updateFiles) {
      if (address > 0L && item
        .getFlashType() == part.getFlashType() && (item
        .getFlashIndex() & 0xFFFF) == (part.getFlashIndex() & 0xFFFF)) {
        item.setStartAddress(address);
        if (item.getLength() > 0L)
          address += item.getLength(); 
        item.setEndAddress(address);
      } 
      if (item == part) {
        address = part.getStartAddress() + ((part.getLength() < 0L) ? 0L : part.getLength());
        item.setEndAddress(part.getStartAddress() + part.getLength());
      } 
    } 
    this.viewer.refresh();
  }
  
  protected boolean checkAddressIsConflict(UpgradeFileInfo newFile, List<UpgradeFileInfo> files) {
    if (files == null || files.size() == 0)
      return false; 
    UpgradeFileInfo file = null;
    for (int i = 0; i < files.size(); i++) {
      file = files.get(i);
      if (!file.equals(newFile))
        if (file.getFlashType().equals(newFile.getFlashType()) && (file
          .getFlashIndex() & 0xFFFF) == (newFile
          .getFlashIndex() & 0xFFFF))
          if ((FlashType.emmc != newFile.getFlashType() && newFile.getFlashType() != FlashType.ssd) || BurnType.BURN_TYPE_PART != newFile
            .getBurnType())
            if ((file.getStartAddress() <= newFile.getStartAddress() && newFile
              .getStartAddress() < file.getEndAddress()) || (newFile
              .getStartAddress() <= file.getStartAddress() && file
              .getStartAddress() < newFile.getEndAddress())) {
              showError(Messages.SelectFileDialog_39);
              return true;
            }    
    } 
    return false;
  }
  
  protected void updateAddressesForAddNew(UpgradeFileInfo part, int index) {
    UpgradeFileInfo item = this.updateFiles.get(index);
    long address = item.getStartAddress();
    if (item.getStartAddress() > 0L)
      address += item.getLength(); 
    for (int i = index + 1; i < this.updateFiles.size(); i++) {
      item = this.updateFiles.get(i);
      if (item.getFlashType() == part.getFlashType() && (item
        .getFlashIndex() & 0xFFFF) == (part.getFlashIndex() & 0xFFFF)) {
        item.setStartAddress(address);
        if (item.getLength() > 0L)
          address += item.getLength(); 
        item.setEndAddress(address);
      } 
    } 
    this.viewer.refresh();
  }
  
  public void dispose() {
    GlobleControler.intance.removeRunnerStateChangedListener(this);
    super.dispose();
  }
}
